#include<iostream>
#include<string>

using namespace std;


main()
{
	int n, c, q, i, j, k, p;
	cin>>n>>c>>q;
	getchar();
	
	int nula=0, jed=0;
	
	string s;
	cin>>s;
	int L[q],R[q];
	for(i=0; i<q; i++)
	{
		cin>>L[i]>>R[i];
	}
	for(i=0; i<q; i++)
	{
		j=L[i]-1;
		while(j<R[i])
		{
			if(s[j]=='0')
				s[j]='1';
			else if(s[j]=='1')
				s[j]='0';
			j++;
		}
		
		j=0;
		while(j<n)
		{
			if(s[j]=='1')
			{
				k=j; 
				break;
			}
			j++;
		}
		
		for(j=n-1; j>=0; j--)
		{
			if(s[j]=='1')
			{
				p=j; break;
			}
		}
		
		for(j=k; j<=p; j++)
		{
			if(s[j]=='0')
			{
				nula++;
			}
			if(s[j]=='1')
			{
				jed++;
			}
		}
		
		if(jed - nula <= 1)
			cout<<jed;
		else
		    cout<<nula+c;
	}
}